import re
import StringIO, pprint

# from  version 2.0 of ABFHEADR.H
# cleaned: removed GUID, ';', 'unsigned' and comments, get rid of spaces between id and []
hdrstr ="""
   float    fFileVersionNumber
   short    nOperationMode
   long     lActualAcqLength
   short    nNumPointsIgnored
   long     lActualEpisodes
   UINT     uFileStartDate       
   UINT     uFileStartTimeMS
   long     lStopwatchTime
   float    fHeaderVersionNumber
   short    nFileType
   long     lDataSectionPtr
   long     lTagSectionPtr
   long     lNumTagEntries
   long     lScopeConfigPtr
   long     lNumScopes
   long     lDeltaArrayPtr
   long     lNumDeltas
   long     lVoiceTagPtr
   long     lVoiceTagEntries
   long     lSynchArrayPtr
   long     lSynchArraySize
   short    nDataFormat
   short    nSimultaneousScan
   long     lStatisticsConfigPtr
   long     lAnnotationSectionPtr
   long     lNumAnnotations
   long     lDACFilePtr[ABF_DACCOUNT]
   long     lDACFileNumEpisodes[ABF_DACCOUNT]


   short    nADCNumChannels
   float    fADCSequenceInterval
   UINT     uFileCompressionRatio
   bool     bEnableFileCompression
   float    fSynchTimeUnit
   float    fSecondsPerRun
   long     lNumSamplesPerEpisode
   long     lPreTriggerSamples
   long     lEpisodesPerRun
   long     lRunsPerTrial
   long     lNumberOfTrials
   short    nAveragingMode
   short    nUndoRunCount
   short    nFirstEpisodeInRun
   float    fTriggerThreshold
   short    nTriggerSource
   short    nTriggerAction
   short    nTriggerPolarity
   float    fScopeOutputInterval
   float    fEpisodeStartToStart
   float    fRunStartToStart
   float    fTrialStartToStart
   long     lAverageCount
   short    nAutoTriggerStrategy
   float    fFirstRunDelayS


   short    nDataDisplayMode
   short    nChannelStatsStrategy
   long     lSamplesPerTrace
   long     lStartDisplayNum
   long     lFinishDisplayNum
   short    nShowPNRawData
   float    fStatisticsPeriod
   long     lStatisticsMeasurements
   short    nStatisticsSaveStrategy


   float    fADCRange
   float    fDACRange
   long     lADCResolution
   long     lDACResolution
   short    nDigitizerADCs
   short    nDigitizerDACs
   short    nDigitizerTotalDigitalOuts
   short    nDigitizerSynchDigitalOuts
   short    nDigitizerType


   short    nExperimentType
   short    nManualInfoStrategy
   float    fCellID1
   float    fCellID2
   float    fCellID3
   char     sProtocolPath[ABF_PATHLEN]
   char     sCreatorInfo[ABF_CREATORINFOLEN]
   char     sModifierInfo[ABF_CREATORINFOLEN]
   short    nCommentsEnable
   char     sFileComment[ABF_FILECOMMENTLEN]
   short    nTelegraphEnable[ABF_ADCCOUNT]
   short    nTelegraphInstrument[ABF_ADCCOUNT]
   float    fTelegraphAdditGain[ABF_ADCCOUNT]
   float    fTelegraphFilter[ABF_ADCCOUNT]
   float    fTelegraphMembraneCap[ABF_ADCCOUNT]
   float    fTelegraphAccessResistance[ABF_ADCCOUNT]
   short    nTelegraphMode[ABF_ADCCOUNT]
   short    nTelegraphDACScaleFactorEnable[ABF_DACCOUNT]

   short    nAutoAnalyseEnable

   float    fInstrumentHoldingLevel[ABF_DACCOUNT]
   long     ulFileCRC
   short    nCRCEnable


   short    nSignalType          
   short    nADCPtoLChannelMap[ABF_ADCCOUNT]
   short    nADCSamplingSeq[ABF_ADCCOUNT]
   float    fADCProgrammableGain[ABF_ADCCOUNT]
   float    fADCDisplayAmplification[ABF_ADCCOUNT]
   float    fADCDisplayOffset[ABF_ADCCOUNT]       
   float    fInstrumentScaleFactor[ABF_ADCCOUNT]  
   float    fInstrumentOffset[ABF_ADCCOUNT]       
   float    fSignalGain[ABF_ADCCOUNT]
   float    fSignalOffset[ABF_ADCCOUNT]
   float    fSignalLowpassFilter[ABF_ADCCOUNT]
   float    fSignalHighpassFilter[ABF_ADCCOUNT]
   char     nLowpassFilterType[ABF_ADCCOUNT]
   char     nHighpassFilterType[ABF_ADCCOUNT]

   char     sADCChannelName[ABF_ADCCOUNT][ABF_ADCNAMELEN]
   char     sADCUnits[ABF_ADCCOUNT][ABF_ADCUNITLEN]
   float    fDACScaleFactor[ABF_DACCOUNT]
   float    fDACHoldingLevel[ABF_DACCOUNT]
   float    fDACCalibrationFactor[ABF_DACCOUNT]
   float    fDACCalibrationOffset[ABF_DACCOUNT]
   char     sDACChannelName[ABF_DACCOUNT][ABF_DACNAMELEN]
   char     sDACChannelUnits[ABF_DACCOUNT][ABF_DACUNITLEN]


   short    nDigitalEnable
   short    nActiveDACChannel        
   short    nDigitalDACChannel
   short    nDigitalHolding
   short    nDigitalInterEpisode
   short    nDigitalTrainActiveLogic                                   
   short    nDigitalValue[ABF_EPOCHCOUNT]
   short    nDigitalTrainValue[ABF_EPOCHCOUNT]                         
   bool     bEpochCompression[ABF_EPOCHCOUNT]
   short    nWaveformEnable[ABF_DACCOUNT]
   short    nWaveformSource[ABF_DACCOUNT]
   short    nInterEpisodeLevel[ABF_DACCOUNT]
   short    nEpochType[ABF_DACCOUNT][ABF_EPOCHCOUNT]
   float    fEpochInitLevel[ABF_DACCOUNT][ABF_EPOCHCOUNT]
   float    fEpochLevelInc[ABF_DACCOUNT][ABF_EPOCHCOUNT]
   long     lEpochInitDuration[ABF_DACCOUNT][ABF_EPOCHCOUNT]
   long     lEpochDurationInc[ABF_DACCOUNT][ABF_EPOCHCOUNT]


   float    fDACFileScale[ABF_DACCOUNT]
   float    fDACFileOffset[ABF_DACCOUNT]
   long     lDACFileEpisodeNum[ABF_DACCOUNT]
   short    nDACFileADCNum[ABF_DACCOUNT]
   char     sDACFilePath[ABF_DACCOUNT][ABF_PATHLEN]


   short    nConditEnable[ABF_DACCOUNT]
   long     lConditNumPulses[ABF_DACCOUNT]
   float    fBaselineDuration[ABF_DACCOUNT]
   float    fBaselineLevel[ABF_DACCOUNT]
   float    fStepDuration[ABF_DACCOUNT]
   float    fStepLevel[ABF_DACCOUNT]
   float    fPostTrainPeriod[ABF_DACCOUNT]
   float    fPostTrainLevel[ABF_DACCOUNT]
   short    nMembTestEnable[ABF_DACCOUNT]
   float    fMembTestPreSettlingTimeMS[ABF_DACCOUNT]
   float    fMembTestPostSettlingTimeMS[ABF_DACCOUNT]


   short    nULEnable[ABF_USERLISTCOUNT]
   short    nULParamToVary[ABF_USERLISTCOUNT]
   short    nULRepeat[ABF_USERLISTCOUNT]
   char     sULParamValueList[ABF_USERLISTCOUNT][ABF_USERLISTLEN]


   short    nStatsEnable
   short nStatsActiveChannels            
   short nStatsSearchRegionFlags         
   short    nStatsSmoothing
   short    nStatsSmoothingEnable
   short    nStatsBaseline
   short    nStatsBaselineDAC                     
   long     lStatsBaselineStart
   long     lStatsBaselineEnd
   long     lStatsMeasurements[ABF_STATS_REGIONS] 
   long     lStatsStart[ABF_STATS_REGIONS]
   long     lStatsEnd[ABF_STATS_REGIONS]
   short    nRiseBottomPercentile[ABF_STATS_REGIONS]
   short    nRiseTopPercentile[ABF_STATS_REGIONS]
   short    nDecayBottomPercentile[ABF_STATS_REGIONS]
   short    nDecayTopPercentile[ABF_STATS_REGIONS]
   short    nStatsChannelPolarity[ABF_ADCCOUNT]
   short    nStatsSearchMode[ABF_STATS_REGIONS]   
   short    nStatsSearchDAC[ABF_STATS_REGIONS]    


   short    nArithmeticEnable
   short    nArithmeticExpression
   float    fArithmeticUpperLimit
   float    fArithmeticLowerLimit
   short    nArithmeticADCNumA
   short    nArithmeticADCNumB
   float    fArithmeticK1
   float    fArithmeticK2
   float    fArithmeticK3
   float    fArithmeticK4
   float    fArithmeticK5
   float    fArithmeticK6
   char     sArithmeticOperator[ABF_ARITHMETICOPLEN]
   char     sArithmeticUnits[ABF_ARITHMETICUNITSLEN]


   short    nPNPosition
   short    nPNNumPulses
   short    nPNPolarity
   float    fPNSettlingTime
   float    fPNInterpulse
   short    nLeakSubtractType[ABF_DACCOUNT]
   float    fPNHoldingLevel[ABF_DACCOUNT]
   bool     bEnabledDuringPN[ABF_ADCCOUNT]


   short    nLevelHysteresis
   long     lTimeHysteresis
   short    nAllowExternalTags
   short    nAverageAlgorithm
   float    fAverageWeighting
   short    nUndoPromptStrategy
   short    nTrialTriggerSource
   short    nStatisticsDisplayStrategy
   short    nExternalTagType
   long     lHeaderSize
   short    nStatisticsClearStrategy
   

   long     lEpochPulsePeriod[ABF_DACCOUNT][ABF_EPOCHCOUNT]
   long     lEpochPulseWidth[ABF_DACCOUNT][ABF_EPOCHCOUNT]


   short    nCreatorMajorVersion
   short    nCreatorMinorVersion
   short    nCreatorBugfixVersion
   short    nCreatorBuildVersion
   short    nModifierMajorVersion
   short    nModifierMinorVersion
   short    nModifierBugfixVersion
   short    nModifierBuildVersion


   short    nLTPType
   short    nLTPUsageOfDAC[ABF_DACCOUNT]
   short    nLTPPresynapticPulses[ABF_DACCOUNT]


   short    nScopeTriggerOut


   short    nAlternateDACOutputState
   short    nAlternateDigitalOutputState
   short    nAlternateDigitalValue[ABF_EPOCHCOUNT]
   short    nAlternateDigitalTrainValue[ABF_EPOCHCOUNT]


   float    fPostProcessLowpassFilter[ABF_ADCCOUNT]
   char     nPostProcessLowpassFilterType[ABF_ADCCOUNT]


   float    fLegacyADCSequenceInterval
   float    fLegacyADCSecondSequenceInterval
   long     lLegacyClockChange
   long     lLegacyNumSamplesPerEpisode
"""
fp = StringIO.StringIO(hdrstr)
lines = [ ss.split() for ss in fp]
lines = [ line for line in lines if line ]


array_re = re.compile(r'(?P<id>\w+)\[(?P<len>\w*)\]')
array2d_re = re.compile(r'(?P<id>\w+)\[(?P<len0>\w*)\]\[(?P<len1>\w*)\]')
class NotCategorized:
    pass

def categorize_line(line):
    """
    categories:
    0 simple vars
    1 string arrays
    2 2D arrays of simple
    3 2D arrays of strings
    4 1D arrays of simple
    """
    ss = line[1]
    axtype = ss[0] # axon's category for this
    m2 = array2d_re.match(ss)
    if m2:
        # print "m2:", ss,
        d = m2.groupdict()
        if axtype == 's':
            mytype = "2dstring"
            return dict(category=mytype, ctype=ss[0], key=d['id'][1:], id=d['id'], len0=d['len0'],
                        len1=d['len1'], orig=ss)
        else: # axtype == n?
            mytype = "2dsimple"
            return dict(category=mytype, ctype=ss[0], key=d['id'][1:], id=d['id'],
                        len0=d['len0'],len1=d['len1'], orig=ss)
            
    m = array_re.match(ss)
    if m:

        d = m.groupdict()
        if axtype== 's':
            mytype = "stringarray"
            return dict(category=mytype, ctype=ss[0], key=d['id'][1:], id=d['id'], len=d['len'],
                        orig=ss)
        else:
            mytype = "1darray"
            return dict(category=mytype, ctype=ss[0], key=d['id'][1:], id=d['id'], len=d['len'],
                        orig=ss)
    if not '[' in ss:
        mytype = "simplevar"
        return dict(category=mytype, ctype=ss[0], key=ss[1:], id=ss, orig=ss)

    # finally could't categorize it
    raise NotCategorized, line
 


catlines = []
for ll in lines:
    catlines.append(categorize_line(ll))

def key_production(cline):
    return """PyString_FromString("%s")""" % cline[5]

var_prod_dict = {
    'f' : 'PyFloat_FromDouble',
    'n' : 'PyInt_FromLong',
    'l' : 'PyLong_FromLong',
    'u' : 'PyInt_FromLong',
    'b' : 'PyBool_FromLong',
    's' : 'PyString_FromString',  # string "array"
    }
def val_production(cline):
    if not cline[2]: # regular variable
        pass
        
production_list = ["PyObject *tmpval=NULL, *tmplist=NULL, *tmplist1;"]
# use tmplist, tmpval
for var in catlines:
    if var['category']=='simplevar':
        # print var
        var['creation'] = '''tmpval = %s(FH.%s)''' % (var_prod_dict[var['ctype']], var['id'])
        var['converter'] = '''%s(FH.%s)''' % (var_prod_dict[var['ctype']], var['id'])
        production_list.append(
            '''%(creation)s; PyDict_SetItem(dict, PyString_FromString("%(key)s"), tmpval);  Py_DECREF(tmpval); /*%(category)s %(orig)s*/''' % var)

    if var['category'] == 'stringarray':
        # it seems these are null terminated strings
        var['creation'] = '''tmpval = PyString_FromString(FH.%s)''' % (var['id'])
#        var['creation'] = '''tmpval = PyString_FromStringAndSize(FH.%s, %s)''' % (var['id'], var['len'])
        production_list.append(
            '''%(creation)s; PyDict_SetItem(dict, PyString_FromString("%(key)s"), tmpval); Py_DECREF(tmpval); /*%(category)s %(orig)s*/''' % var)

    if var['category'] == '1darray':
        tmps=[]
        var['converter'] = '''%s(FH.%s[ii])''' % (var_prod_dict[var['ctype']], var['id'])

        tmps.append('''
        tmplist = PyList_New(0);  /*%(category)s %(orig)s*/''' % var)
        tmps.append('''
          for(int ii=0; ii < %(len)s; ii++) {
          tmpval = %(converter)s;
          PyList_Append(tmplist, tmpval);
          Py_DECREF(tmpval);
        }
        ''' % var)
        tmps.append('''PyDict_SetItem(dict, PyString_FromString("%(key)s"), tmplist);
                Py_DECREF(tmplist); tmplist=NULL;\n''' % var)
        production_list.append("\n".join(tmps))
        # pprint.pprint(var)

    if var['category'] == '2dstring':
        # try as a 1d array of strings
        # pprint.pprint(var)
        tmps=[]
        var['converter'] = '''%s(FH.%s[ii])''' % (var_prod_dict[var['ctype']], var['id'])

        tmps.append('''
        tmplist = PyList_New(0);  /*%(category)s %(orig)s*/''' % var)
        tmps.append('''
          for(int ii=0; ii < %(len0)s; ii++) {
          tmpval = %(converter)s;
          PyList_Append(tmplist, tmpval);
          Py_DECREF(tmpval);
        }
        ''' % var)
        tmps.append('''PyDict_SetItem(dict, PyString_FromString("%(key)s"), tmplist);
                Py_DECREF(tmplist); tmplist=NULL;\n''' % var)
        production_list.append("\n".join(tmps))

    if var['category'] == '2dsimple':
        pprint.pprint(var)        
        tmps=[]
        var['converter'] = '''%s(FH.%s[ii][jj])''' % (var_prod_dict[var['ctype']], var['id'])
        print "\t", var['converter']

        tmps.append('''
        tmplist = PyList_New(0);  /*%(category)s %(orig)s*/''' % var)
        tmps.append('''
        for(int ii=0; ii < %(len0)s; ii++) {
            tmplist1 = PyList_New(0);
            for(int jj=0; jj < %(len1)s; jj++) {
                tmpval = %(converter)s;
                PyList_Append(tmplist1, tmpval);
                Py_DECREF(tmpval);
            }
            PyList_Append(tmplist, tmplist1);
            Py_DECREF(tmplist1);
        }
        ''' % var)
        # now add to the ongoing dict were building up
        tmps.append('''
        PyDict_SetItem(dict, PyString_FromString("%(key)s"), tmplist);
        Py_DECREF(tmplist); tmplist=NULL;\n''' % var)
        production_list.append("\n".join(tmps))


    if var['category'] == '2darray': # reserve for numpy arrays?
        print "warning not handled yet"
        pprint.pprint(var)
    

open('abf_hdr_snippet2.c', 'wb+').write("\n".join(production_list))
