#!c:\Python26\python.exe
"""
convert axon abf file data to text formats
"""
import os, glob,sys, fnmatch, subprocess
from pprint import pprint

#all = glob.glob('*.abf')
# default flags/config

abf2txtbin = 'abf2txt.exe'
class Optionsclass(object):
    def __str__(self):
        return str(self.__dict__)

    def __repr__(self):
        return 'Optionsclass:' + repr(self.__dict__)
global_options = Optionsclass()
global_options.reconvert = False # set to True if you want to reconvert already converted files
global_options.quiet = False


def main():
    from optparse import OptionParser
    parser = OptionParser(usage="""usage: %prog [options]

If run without any options, %prog will find all the files ending with
.abf and produce a text file ending with .abf.txt with the data in
ascii format and it will produce a second file ending with .abf-md.txt
which contains the metadata about the file like the gain, units etc.
    """)
    parser.add_option("-q", "--quiet", action='store_true', dest='quiet',default=False, help='turn off text output during conversion')
    
    parser.add_option( "--redo", action='store_true', dest='reconvert',default=False, help='apply the conversion even if there are already converted versions, defaults to %default')

    options, args = parser.parse_args()
    print options, type(options), options.__class__
    global_options.__dict__.update(options.__dict__)


def do_conversion(abffile):
    if not global_options.quiet:
        print "converting %s" % abffile
    # os.system('%s %s' % (abf2txtbin, abf))
    #p = subprocess.Popen('%s %s' % (abf2txtbin, abf), shell=True)
    #sts = os.waitpid(p.pid, 0)[1]
    try:
        retcode = subprocess.call('%s %s' % (abf2txtbin, abf), shell=True)
        if retcode < 0:
            print >>sys.stderr, abf2txtbin+' was terminated on %s' % abffile
    except OSError, e:
        print >>sys.stederr, "Conversion failed on %s due to %s" % (abffile, e)
    return retcode
    

def txtfilenames(abffile):
    """
    return the metadata 
    """
    return (abffile+'-md.txt', abffile+'.txt')

def already_converted(abffile):
    metafile, datafile = txtfilenames(abffile)
    return os.path.isfile(metafile) and os.path.isfile(datafile)

if __name__=='__main__':
    startdir = os.getcwd()

    main()

    biglist=[]
    walkgen = os.walk(top=startdir, topdown=True)
    # dirpath, dirnames, filenames = walkgen.next()
    for dd in walkgen:
        biglist.append(dd)

    for dirpath, dirnames, filenames in biglist:
        os.chdir(dirpath)
        abffiles = fnmatch.filter(filenames, '*.abf')
        if abffiles:
            for abf in abffiles:
                if global_options.reconvert:
                    os.system('%s %s' % (abf2txtbin, abf))
                else:
                    if not already_converted(abf):
                        os.system('%s %s' % (abf2txtbin, abf))

                    

                

    os.chdir(startdir)

    
